{    programmateur de PIC           }
{    Michel Ousset, mai 95          }

{$I-}

Uses DOS, CRT;

Const AddLPT1  = $3BC;   {adresse de base de LPT1}
      AddLPT2  = $378;   {adresse de base de LPT2}
      AddLPT3  = $278;   {adresse de base de LPT3}
      MaxAdd54 = $1FF;   {adresse mmoire la plus haute}
      MaxAdd55 = $1FF;
      MaxAdd56 = $3FF;
      MaxAdd57 = $7FF;
      MaxAdd58 = $7FF;

Type  Hex   = File of String;
      Quart = Record
         B0 : Byte;
         B1 : Byte;
         B2 : Byte;
         B3 : Byte;
      End;

Var   AddLPT : Integer;
      PIC    : Byte;
      OSC    : Byte;
      WDT    : Byte;
      MaxAdd : Integer;
      ConfW  : Array[0..11] of Byte;     {Mot de configuration}
      VPort  : Byte;
      I      : Byte;
      J      : Byte;
      C      : Char;
      Q      : Quart;
      NomFic : String;
      Map    : Array[0..2047, 1..3] of Char; { B2,B1,B0 }
      Blanc  : Boolean;
      Duree  : Word;

Procedure Sync; {Synchronise les tempos sur l'horloge du systme}
Var H1,  M1    : Word;
    S1,  S2    : Word;
    Ct1, Ct2   : Word;
    I          : Word;
Begin
   GetTime(H1,M1,S1,Ct1);
   For I := 1 to 60000 Do Begin
       I := I + 1;
       I := I - 1;
   End;
   GetTime(H1,M1,S2,Ct2);
   If Ct2 > Ct1 Then I := Ct2 - Ct1
      Else I := Ct2 + (100 - Ct1) - 100;
   If S2  >= S1  Then I := I + (S2-S1) * 100
      Else I := I + (S2 + (60 - S1)) * 100;
   Duree := Word(Round(60000 / I * 0.037));
End;

Procedure Tempo(Tps : Integer);
Var I : Integer;
Begin
   For I := 1 to Tps Do Begin
      I := I + 1;
      I := I - 1;
   End;
End;

Procedure LitHEX;          {Lecture du fichier au format HEX}
Var   I     : Integer;
      N     : Integer;
      Err   : Integer;
      Add   : Integer;
      DtRec : String;
      FHex  : Text;
Begin
   Assign(FHex, NomFic);
   Reset(FHex);             {Ouverture du fichier}
   I := IOResult;
   If I <> 0 Then Begin
      Case I of
         2  :  Write('Fichier Introuvable');
         4  :  Write('Trop de fichiers ouverts simultanment');
         5  :  Write('Accs au fichier interdit');
         Else  Write('Erreur d''entre-sortie n : ',I);
      End; {Case}
      Halt;
   End;
   For I := 0 to 2047 Do Begin  {Initialisation de la zone mmoire}
      Map[I, 1] := 'F';
      Map[I, 2] := 'F';
      Map[I, 3] := 'F';
   End;
   While Not Eof(FHex) Do Begin                               {Lecture du fichier}
      Readln(FHex, DtRec);
      If (DtRec[1] = ':') then Begin                          {Teste Entte}
         If (DtRec[8] <> '0') or ((DtRec[9] <> '0') and (DtRec[9] <> '1')) Then Begin  {Teste format fichier}
            Writeln('Format de fichier incorrect');
            Halt;
         End;
         If (DtRec[8] = '0') and (DtRec[9] = '0') Then Begin  {Teste si ligne de data}
            Val('$' + Copy(DtRec,2,2), N, Err);               {Lecture du nombre de donnes}
            Val('$' + Copy(DtRec,4,4), Add, Err);             {Lecture de l'adresse de base}
            Add := Add Shr 1;
            If N <> 0 Then
               For I := 0 to ((N shr 1) - 1) Do Begin         {Lecture des donnes}
                  Map[Add + I, 1] := DtRec[10 + 4 * I + 1];
                  Map[Add + I, 2] := DtRec[10 + 4 * I + 0];
                  Map[Add + I, 3] := DtRec[10 + 4 * I + 3];
               End;  {For}
         End;    {If}
      End     {If}
      Else Begin
         Writeln('Format de fichier incorrect');
         Halt;
      End;    {Else}
   End;     {While}
   Close(FHex);
End;

Procedure BinToHex(Q : Quart; Var H : Char);
Begin
   If ((Q.B3 = 0) and (Q.B2 = 0) and (Q.B1 = 0) and (Q.B0 = 0)) Then H := '0';
   If ((Q.B3 = 0) and (Q.B2 = 0) and (Q.B1 = 0) and (Q.B0 = 1)) Then H := '1';
   If ((Q.B3 = 0) and (Q.B2 = 0) and (Q.B1 = 1) and (Q.B0 = 0)) Then H := '2';
   If ((Q.B3 = 0) and (Q.B2 = 0) and (Q.B1 = 1) and (Q.B0 = 1)) Then H := '3';
   If ((Q.B3 = 0) and (Q.B2 = 1) and (Q.B1 = 0) and (Q.B0 = 0)) Then H := '4';
   If ((Q.B3 = 0) and (Q.B2 = 1) and (Q.B1 = 0) and (Q.B0 = 1)) Then H := '5';
   If ((Q.B3 = 0) and (Q.B2 = 1) and (Q.B1 = 1) and (Q.B0 = 0)) Then H := '6';
   If ((Q.B3 = 0) and (Q.B2 = 1) and (Q.B1 = 1) and (Q.B0 = 1)) Then H := '7';
   If ((Q.B3 = 1) and (Q.B2 = 0) and (Q.B1 = 0) and (Q.B0 = 0)) Then H := '8';
   If ((Q.B3 = 1) and (Q.B2 = 0) and (Q.B1 = 0) and (Q.B0 = 1)) Then H := '9';
   If ((Q.B3 = 1) and (Q.B2 = 0) and (Q.B1 = 1) and (Q.B0 = 0)) Then H := 'A';
   If ((Q.B3 = 1) and (Q.B2 = 0) and (Q.B1 = 1) and (Q.B0 = 1)) Then H := 'B';
   If ((Q.B3 = 1) and (Q.B2 = 1) and (Q.B1 = 0) and (Q.B0 = 0)) Then H := 'C';
   If ((Q.B3 = 1) and (Q.B2 = 1) and (Q.B1 = 0) and (Q.B0 = 1)) Then H := 'D';
   If ((Q.B3 = 1) and (Q.B2 = 1) and (Q.B1 = 1) and (Q.B0 = 0)) Then H := 'E';
   If ((Q.B3 = 1) and (Q.B2 = 1) and (Q.B1 = 1) and (Q.B0 = 1)) Then H := 'F';
End;

Procedure HexToBin(H : Char; Var Q : Quart);
Begin
   Case H Of
      '0': Begin Q.B3 := 0; Q.B2 := 0; Q.B1 := 0; Q.B0 := 0; End;
      '1': Begin Q.B3 := 0; Q.B2 := 0; Q.B1 := 0; Q.B0 := 1; End;
      '2': Begin Q.B3 := 0; Q.B2 := 0; Q.B1 := 1; Q.B0 := 0; End;
      '3': Begin Q.B3 := 0; Q.B2 := 0; Q.B1 := 1; Q.B0 := 1; End;
      '4': Begin Q.B3 := 0; Q.B2 := 1; Q.B1 := 0; Q.B0 := 0; End;
      '5': Begin Q.B3 := 0; Q.B2 := 1; Q.B1 := 0; Q.B0 := 1; End;
      '6': Begin Q.B3 := 0; Q.B2 := 1; Q.B1 := 1; Q.B0 := 0; End;
      '7': Begin Q.B3 := 0; Q.B2 := 1; Q.B1 := 1; Q.B0 := 1; End;
      '8': Begin Q.B3 := 1; Q.B2 := 0; Q.B1 := 0; Q.B0 := 0; End;
      '9': Begin Q.B3 := 1; Q.B2 := 0; Q.B1 := 0; Q.B0 := 1; End;
      'A': Begin Q.B3 := 1; Q.B2 := 0; Q.B1 := 1; Q.B0 := 0; End;
      'B': Begin Q.B3 := 1; Q.B2 := 0; Q.B1 := 1; Q.B0 := 1; End;
      'C': Begin Q.B3 := 1; Q.B2 := 1; Q.B1 := 0; Q.B0 := 0; End;
      'D': Begin Q.B3 := 1; Q.B2 := 1; Q.B1 := 0; Q.B0 := 1; End;
      'E': Begin Q.B3 := 1; Q.B2 := 1; Q.B1 := 1; Q.B0 := 0; End;
      'F': Begin Q.B3 := 1; Q.B2 := 1; Q.B1 := 1; Q.B0 := 1; End;
   End;
End;

Procedure Start;
Begin
   VPort := VPort OR $03;
   Port[AddLPT] := VPort; {CLK = 1, DIN = 1}
   Tempo(Duree);
   VPort := VPort AND $FD;
   Port[AddLPT] := VPort; {CLK = 1, DIN = 0}
   Tempo(Duree);
End;

Procedure S0; { Emet un 0 vers le ST6 }
Begin
   VPort := VPort AND $FE; {CLK = 0}
   Port[AddLPT] := VPort;
   Tempo(Duree);
   VPort := VPort AND $FD; {DIN = 0}
   Port[AddLPT] := VPort;
   Tempo(Duree);
   VPort := VPort OR $01;  {CLK = 1}
   Port[AddLPT] := VPort;
   Tempo(Duree);
End;

Procedure S1; { Emet un 1 vers le ST6 }
Begin
   VPort := VPort AND $FE; {CLK = 0}
   Port[AddLPT] := VPort;
   Tempo(Duree);
   VPort := VPort OR $02;  {DIN = 1}
   Port[AddLPT] := VPort;
   Tempo(Duree);
   VPort := VPort OR $01;  {CLK = 1}
   Port[AddLPT] := VPort;
   Tempo(Duree);
End;

Function LB : Byte; {Lit un bit mis par le ST6, Pds fort en tte}
Begin
   VPort := VPort AND $FE; {CLK = 0}
   Port[AddLPT] := VPort;
   Tempo(Duree);
   VPort := VPort OR $01;  {CLK = 1}
   Port[AddLPT] := VPort;
   Tempo(Duree);
   if (Port[AddLPT + 1] And $40) = 64
      then LB := 1
      else LB := 0;
End;

Procedure PowerON; {Applique la tension d'alimentation de programmation}
Begin
   VPort := VPort AND $F7; {Bit 3, metteur de T2  0}
   Port[AddLPT] := VPort;
   VPort := VPort OR $04;  {Bit 2, base de T2  1}
   Port[AddLPT] := VPort;
End;

Procedure PowerOFF; {Coupe la tension d'alimentation de programmation}
Begin
   VPort := VPort OR $08;  {Bit 3, metteur de T2  1}
   Port[AddLPT] := VPort;
   VPort := VPort AND $FB; {Bit 2, base de T2  0}
   Port[AddLPT] := VPort;
End;

Procedure CDE00;   {Appliquer Vddp}
Begin
   S0; S0; S0; S0;
End;

Procedure CDE01;   {Excuter Vddp = OFF}
Begin
   S0; S0; S0; S1;
End;

Procedure CDE02;   {Appliquer Vpp}
Begin
   S0; S0; S1; S0;
End;

Procedure CDE03;   {Excuter Vpp = OFF}
Begin
   S0; S0; S1; S1;
End;

Procedure CDE04;   {Excuter TOCKI = 0}
Begin
   S0; S1; S0; S0;
End;

Procedure CDE05;   {Excuter TOCKI = 1}
Begin
   S0; S1; S0; S1;
End;

Procedure CDE06;   {Excuter TOCKI = 0 pendant 10000s}
Begin
   S0; S1; S1; S0;
   Repeat
   Until (Port[AddLPT + 1] And $40) = 64; {Attend le 1 en rponse}
   Repeat
   Until (Port[AddLPT + 1] And $40) = 0;  {Attend le 0 en rponse}
End;

Procedure CDE07;   {Excuter TOCKI = 0 pendant 50s}
Begin
   S0; S1; S1; S1;
End;

Procedure CDE08;   {Excuter OSC1 = 0}
Begin
   S1; S0; S0; S0;
End;

Procedure CDE09;   {Excuter OSC1 = 1}
Begin
   S1; S0; S0; S1;
End;

Procedure CDE10;   {Placer port entre C et PIC en entre}
Begin
   S1; S0; S1; S0;
End;

Procedure CDE11;   {Placer port entre C et PIC en sortie}
Begin
   S1; S0; S1; S1;
End;

Procedure CDE12;   {Lire PIC et envoyer donnes au PC}
Begin
   S1; S1; S0; S0;
End;

Procedure CDE13;   {Lire PC et envoyer donnes au PIC}
Begin
   S1; S1; S0; S1;
End;

Procedure CDE14;   {Placer port de contrle entre C et PIC en entre}
Begin
   S1; S1; S1; S0;
End;

Procedure CDE15;   {Placer port de contrle entre C et PIC en sortie}
Begin
   S1; S1; S1; S1;
End;

Procedure Init;
Var Message : String;
    I, J    : Integer;
    DirInfo : SearchRec;
    Ch      : Char;
    Err     : Integer;
    N       : Integer;
    Chk     : Real;
    Q       : Quart;
Begin
   {  Initialisation de la dure de base de Tempo }
   Sync;
   {  Initialisation des paramtres d'environnement }
   CheckBreak := True;
   TextMode(C80);
   {  Affichage entte page }
   Window(1,1,80,3);
   TextBackGround(lightCyan);
   TextColor(Black);
   ClrScr;
   Message := 'Programmateur  de  PIC  1 6 C 5 X';
   GotoXY((80 - Length(Message)) shr 1, 2);
   Write(Message);
   {  Prparation page de travail }
   Window(1,4,80,25);
   TextBackGround(LightBlue);
   TextColor(LightCyan);
   ClrScr;
   {  Aquisition nom du fichier }
   Repeat
      GotoXY(2,2); ClrEol;
      Write('Nom du fichier : ');
      Readln(NomFic);
      FindFirst(NomFic,AnyFile,DirInfo);
      I := DosError;
      If I <> 0 Then Begin
         GotoXY(2,2); ClrEol;
         Write('Fichier ''',NomFic,''' non trouv. Pressez une touche ...');
         Repeat Until Keypressed;
         Ch := ReadKey;
      End;
   Until I = 0;
   {  lecture et affichage du fichier }
   LitHex;
   GotoXY(1,2);
   Writeln(' Ŀ');
   Message := ' '+DirInfo.Name+' ';
   GotoXY(1+(42 - Length(Message)) shr 1, 2);
   Write(Message);
   For J := 0 to 8 Do Begin
      GotoXY(2,3+J);
      Write(' 0',(J*8) div 16,(J*8) mod 16,': ');
      For I := 0 to 7 Do Write(Map[J*8+I,3],Map[J*8+I,2],Map[J*8+I,1],' ');
      Writeln('');
   End;
   Writeln(' ');
   For I := 2 to 12 Do Begin
      GotoXY(44,I);
      Write('');
   End;
   {  lecture du port d'imprimante }
   GotoXY(50,13); Write('Ŀ');
   GotoXY(50,14); Write(' 1 : LPT1 ');
   GotoXY(50,15); Write(' 2 : LPT2 ');
   GotoXY(50,16); Write(' 3 : LPT3 ');
   GotoXY(50,17); Write('');
   GotoXY(2,14);  Write('Port de liaison avec le programmateur ? ');
   Repeat Ch := Readkey;
   Until (Ch = '1') or (Ch = '2') or (Ch = '3');
   GotoXY(2,14); ClrEol;
   GotoXY(47,2); Write('Port de liaison ');
   Case Ch of
      '1' : Begin
              Write('LPT1');
              AddLPT := AddLPT1;
            End;
      '2' : Begin
              Write('LPT2');
              AddLPT := AddLPT2;
            End;
      '3' : Begin
              Write('LPT3');
              AddLPT := AddLPT3;
            End;
   End;
   GotoXY(50,13); ClrEol;
   GotoXY(50,14); ClrEol;
   GotoXY(50,15); ClrEol;
   GotoXY(50,16); ClrEol;
   GotoXY(50,17); ClrEol;
   {  Initialisation des paramtres du CPU }
   Start; CDE01;  {VddP = 0}
   Start; CDE03;  {Vpp  = 0}
   Start; CDE10;  {Port de donnes en entre}
   Start; CDE14;  {Port de contrle en entre}
   {  lecture du type de CPU }
   GotoXY(50,13); Write('Ŀ');
   GotoXY(50,14); Write(' 1 : 16C54 ');
   GotoXY(50,15); Write(' 2 : 16C55 ');
   GotoXY(50,16); Write(' 3 : 16C56 ');
   GotoXY(50,17); Write(' 4 : 16C57 ');
   GotoXY(50,18); Write(' 5 : 16C58 ');
   GotoXY(50,19); Write('');
   GotoXY(2,14);  Write('Type de composant ? ');
   Repeat Ch := ReadKey;
   Until (Ch = '1') or (Ch = '2') or (Ch = '3') or (Ch = '4') or (Ch = '5');
   GotoXY(2,14); ClrEol;
   GotoXY(47,4);
   Case Ch of
      '1': Begin
             Write('PIC 16C54');
             MaxAdd := MaxAdd54;
             PIC := 1;
           End;
      '2': Begin
             Write('PIC 16C55');
             MaxAdd := MaxAdd55;
             PIC := 2;
           End;
      '3': Begin
             Write('PIC 16C56');
             MaxAdd := MaxAdd56;
             PIC := 3;
           End;
      '4': Begin
             Write('PIC 16C57');
             MaxAdd := MaxAdd57;
             PIC := 4;
           End;
      '5': Begin
             Write('PIC 16C58');
             MaxAdd := MaxAdd58;
             PIC := 5;
           End;
   End;
   GotoXY(50,13); ClrEol;
   GotoXY(50,14); ClrEol;
   GotoXY(50,15); ClrEol;
   GotoXY(50,16); ClrEol;
   GotoXY(50,17); ClrEol;
   GotoXY(50,18); ClrEol;
   GotoXY(50,19); ClrEol;
   {  lecture du type d'oscillateur }
   GotoXY(30,13); Write('Ŀ');
   GotoXY(30,14); Write(' 1 : RC, Resistor / Capacitor           ');
   GotoXY(30,15); Write(' 2 : LP, Low power crystal, < 200Khz    ');
   GotoXY(30,16); Write(' 3 : XT, Standard crystal, 4Mhz max.    ');
   GotoXY(30,17); Write(' 4 : HS, High Speed crystal, 20Mhz max. ');
   GotoXY(30,18); Write('');
   GotoXY(2,14);  Write('Type d''oscillateur ? ');
   Repeat Ch := ReadKey;
   Until (Ch = '1') or (Ch = '2') or (Ch = '3') or (Ch = '4') ;
   GotoXY(2,14); ClrEol;
   GotoXY(47,6);
   Case Ch of
      '1' : Begin
              Write('Oscillateur type RC');
              OSC := 1;
            End;
      '2' : Begin
              Write('Oscillateur type LP');
              OSC := 2;
            End;
      '3' : Begin
              Write('Oscillateur type XT');
              OSC := 3;
            End;
      '4' : Begin
              Write('Oscillateur type HS');
              OSC := 4;
            End;
   End;
   GotoXY(30,13); ClrEol;
   GotoXY(30,14); ClrEol;
   GotoXY(30,15); ClrEol;
   GotoXY(30,16); ClrEol;
   GotoXY(30,17); ClrEol;
   GotoXY(30,18); ClrEol;
   {  lecture du type de Watchdog }
   GotoXY(2,14);
   Write('Activation du Watchdog (Oui, Non) ? ');
   Repeat Ch := ReadKey;
   Until (UpCase(Ch) = 'O') or (UpCase(Ch) = 'N');
   GotoXY(2,14); ClrEol;
   GotoXY(47,8);
   Case UpCase(Ch) Of
      'O' : Begin
              Write('Watchdog ON');
              WDT := 1;
            End;
      'N' : Begin
              Write('Watchdog OFF');
              WDT := 0;
            End;
   End;
   GotoXY(2,14);
   {  Calcul du mot de configuration }
   Case PIC of
      1..4 : For I := 4 to 11 Do ConfW[I] := 1;
      5    : For I := 4 to 11 Do ConfW[I] := 1;
   End;
   ConfW[3] := 1; {Memory unprotected}
   ConfW[2] := WDT; {Watchdog}
   Case OSC of
      1 : Begin {RC}
            ConfW[1] := 1;
            ConfW[0] := 1;
          End;
      2 : Begin {LP}
            ConfW[1] := 0;
            ConfW[0] := 0;
          End;
      3 : Begin {XT}
            ConfW[1] := 0;
            ConfW[0] := 1;
          End;
      4 : Begin {HS}
            ConfW[1] := 1;
            ConfW[0] := 0;
          End;
   End;
   {  Calcul du Checksum }
   chk := 0;
   For I := 0 to MaxAdd do Begin
      Val('$'+Map[I,3]+Map[I,2]+Map[I,1], N, Err);
      Chk := Chk + N;
   End;
   For I := 11 downto 0 Do Chk := Chk + ConfW[I] * Exp(I*Ln(2));
   Message := '';
   For I := 0 to 3 Do Begin
      Chk := Chk / 2;
      If (Chk - Trunc(Chk) = 0) Then  Q.B0 := 0 Else Q.B0 := 1;
      Chk := Trunc(Chk);
      Chk := Chk / 2;
      If (Chk - Trunc(Chk) = 0) Then  Q.B1 := 0 Else Q.B1 := 1;
      Chk := Trunc(Chk);
      Chk := Chk / 2;
      If (Chk - Trunc(Chk) = 0) Then  Q.B2 := 0 Else Q.B2 := 1;
      Chk := Trunc(Chk);
      Chk := Chk / 2;
      If (Chk - Trunc(Chk) = 0) Then  Q.B3 := 0 Else Q.B3 := 1;
      Chk := Trunc(Chk);
      BinToHex(Q,Ch);
      Message := Ch + Message
   End;
   GotoXY(47,10);
   Write('Cheksum : ', Message);
   {  Initialise le port de sortie et le premier Start }
   Port[AddLPT] := $03; {CLK = 1, DIN = 1}
   Tempo(Duree);
   Port[AddLPT] := $01; {CLK = 1, DIN = 0}
   Tempo(Duree);
   VPort := $01;
   Start;
End;

Function BlkChk : Boolean;
{ Vrifie que le Chip peut tre programm }
{ BlkChk = True si Chip vierge            }
Var Add : Integer;
    I   : Byte;
    X,Y : Byte;
Begin
   X := WhereX;
   Y := WhereY;
   PowerON;
   Start; CDE00;  {Alimente le PIC, VddP}
   Start; CDE10;  {Port de donnes en entre}
   Start; CDE15;  {Port de controle en sortie}
   Start; CDE04;  {TOCKI = 0}
   Start; CDE08;  {OSC1  = 0}
   Start; CDE05;  {TOCKI = 1}
   Start; CDE02;  {Applique tension de programmation, Vpp}
   BlkChk := True;

   For Add := -1 to MaxAdd Do Begin  {A cause du mot config}

      GotoXY(X,Y); ClrEol;
      Write(Add);

      Start; CDE09;  {OSC1 = 1}
      Start; CDE12;  {Lire PIC et envoyer donnes}
      For I := 1 to 12 Do
         If LB = 0 Then BlkChk := False;
      Start; CDE08;  {OSC1 = 0}
   End;

   Start; CDE03;  {Vpp = 0}
   Start; CDE14;  {Port de contrle en entre}
   Start; CDE01;  {VddP = 0}
   PowerOFF;
   GotoXY(X,Y); ClrEol;
End;

Procedure P;
Begin
   Repeat Until Keypressed;
End;

Procedure Prog;
{ Programmation du PIC }
Var Add  : Integer;
    I,J  : Byte;
    Data : Array[0..11] of Byte;
    X,Y  : Byte;
Begin
   X := WhereX;
   Y := WhereY;
   PowerON;
   Start; CDE00;  {Alimente le PIC, VddP}
   Start; CDE10;  {Port de donnes en entre}
   Start; CDE15;  {Port de controle en sortie}
   Start; CDE04;  {TOCKI = 0}
   Start; CDE08;  {OSC1  = 0}
   Start; CDE05;  {TOCKI = 1}
   Start; CDE02;  {Applique tension de programmation, Vpp}

   {  Programmation du mot de configuration }
   Start; CDE11;  {Port de donnes en sortie}
   Start; CDE13;  {Emet donnes vers PIC}

   For I := 11 DownTo 0 Do If ConfW[I] = 0 Then S0 Else S1;

   Start; CDE06;  {TOCKI = 0 pdt 10000s}
   Start; CDE10;  {Port de donnes en entre}

   Start; CDE04;  {TOCKI = 0, impulsion de vrification}
   Start; CDE05;  {TOCKI = 1                           }

   Start; CDE09;  {OSC1 = 1, incrmente compteur}
   Start; CDE08;  {OSC1 = 0                     }

   {  Programmation des donnes }

   For Add := 0 to MaxAdd Do Begin
      Start; CDE11;  {Port de donnes en sortie}
      Start; CDE13;  {Emet donnes vers PIC}

      GotoXY(X,Y); ClrEol;
      Write(Add);

      C := Map[Add,3];
      HexToBin(C,Q);
      Data[11] := Q.B3; Data[10] := Q.B2; Data[09] := Q.B1; Data[08] := Q.B0;
      C := Map[Add,2];
      HexToBin(C,Q);
      Data[07] := Q.B3; Data[06] := Q.B2; Data[05] := Q.B1; Data[04] := Q.B0;
      C := Map[Add,1];
      HexToBin(C,Q);
      Data[03] := Q.B3; Data[02] := Q.B2; Data[01] := Q.B1; Data[00] := Q.B0;

      For J := 11 DownTo 0 Do If Data[J] = 1 Then S1 Else S0;

      Start; CDE06;  {TOCKI = 0 pdt 10000s}
      Start; CDE10;  {Port de donnes en entre}

      Start; CDE04;  {TOCKI = 0, impulsion de vrification}
      Start; CDE05;  {TOCKI = 1                           }

      Start; CDE09;  {OSC1 = 1, incrmente compteur}
      Start; CDE08;  {OSC1 = 0                     }

   End;

   Start; CDE10;  {Port de donnes en entre}
   Start; CDE03;  {Vpp = 0}
   Start; CDE14;  {Port de contrle en entre}
   Start; CDE01;  {VddP = 0}
   PowerOFF;
End;

Begin
{
   ClrScr;
   Sync;
   AddLPT := AddLPT3;
   NomFic := 'Timer0.hex';

   PowerON;
   Start; CDE02;
   Start; CDE00;
end.
}
    Init;
    GotoXY(2,14);
    Write('Blanc check : ');
    Blanc := BlkChk;
    GotoXY(2,14);
    ClrEol;
    If Blanc Then Write('Composant prt pour programmation')
       Else Begin
          Write('Composant pas effac, continue programmation (Oui, Non) ? ');
          Repeat C := ReadKey;
          Until (UpCase(C) = 'O') or (UpCase(C) = 'N');
          Write (UpCase(C));
          If UpCase(C) = 'N' Then Halt;
    End;
    GotoXY(2,16);
    Write('Programmation en cours : ');
    Prog;
    GotoXY(2,18);
    Write('Programmation acheve !');
End.
